#!/usr/bin/python

# THIS IS UNFINISHED!!!

from optparse import OptionParser


import sys
from array import array
from T602Parser import T602Parser

SUP_ON_TAG = u'\ue000'
SUP_OFF_TAG = u'\ue001'

SUB_ON_TAG = u'\ue002'
SUB_OFF_TAG = u'\ue003'

WIDE_ON_TAG = u'\ue004'
WIDE_OFF_TAG = u'\ue005'

TALL_ON_TAG = u'\ue006'
TALL_OFF_TAG = u'\ue007'

BIG_ON_TAG = u'\ue008'
BIG_OFF_TAG = u'\ue009'

UNDERLINE_ON_TAG = u'\ue00a'
UNDERLINE_OFF_TAG = u'\ue00b'

BOLD_ON_TAG = u'\ue00c'
BOLD_OFF_TAG = u'\ue00d'

ITALICS_ON_TAG = u'\ue00e'
ITALICS_OFF_TAG = u'\ue00f'
        

    

parser = OptionParser(usage="usage: %prog [options] [inputfile] [outputfile]")

parser.add_option("-s", "--subscript",
      action="store", dest="subscript", type="string",
      help="What to do with subscript: text, unicode, strip",
      default="text")

parser.add_option("-S", "--superscript",
      action="store", dest="superscript", type="string",
      help="What to do with superscript: text, unicode, strip",
      default="text")

parser.add_option("", "--sub-lead",
      action="store", dest="subscript_lead", type="string",
      help="Text to put immediately in front of subscript",
      default="")

parser.add_option("", "--sub-trail",
      action="store", dest="subscript_trail", type="string",
      help="Text to put immediately after subscript text",
      default="")

parser.add_option("", "--sup-lead",
      action="store", dest="superscript_lead", type="string",
      help="Text to put immediately in front of superscript",
      default="")

parser.add_option("", "--sup-trail",
      action="store", dest="superscript_trail", type="string",
      help="Text to put immediately after superscript text",
      default="")

parser.add_option("", "--italics-lead",
      action="store", dest="italics_lead", type="string",
      help="Text to put immediately in front of italics",
      default="")

parser.add_option("", "--italics-trail",
      action="store", dest="italics_trail", type="string",
      help="Text to put immediately after italics text",
      default="")

parser.add_option("", "--bold-lead",
      action="store", dest="bold_lead", type="string",
      help="Text to put immediately in front of bold text",
      default="")

parser.add_option("", "--bold-trail",
      action="store", dest="bold_trail", type="string",
      help="Text to put immediately after bold text",
      default="")

parser.add_option("", "--underline-lead",
      action="store", dest="underline_lead", type="string",
      help="Text to put immediately in front of underlined text",
      default="")

parser.add_option("", "--underline_trail",
      action="store", dest="underline-trail", type="string",
      help="Text to put immediately after underlined text",
      default="")


parser.add_option("", "--wide-lead",
      action="store", dest="wide_lead", type="string",
      help="Text to put immediately in front of wide text",
      default="")

parser.add_option("", "--wide-trail",
      action="store", dest="wide_trail", type="string",
      help="Text to put immediately after wide text",
      default="")

parser.add_option("", "--tall-lead",
      action="store", dest="tall_lead", type="string",
      help="Text to put immediately in front of tall text",
      default="")

parser.add_option("", "--tall-trail",
      action="store", dest="tall_trail", type="string",
      help="Text to put immediately after tall text",
      default="")

parser.add_option("", "--big-lead",
      action="store", dest="big_lead", type="string",
      help="Text to put immediately in front of big text",
      default="")

parser.add_option("", "--big-trail",
      action="store", dest="big_trail", type="string",
      help="Text to put immediately after big text",
      default="")



      
(options, args) = parser.parse_args()


if len(args)==0:
     parser.print_help()
     sys.exit()



class My602Parser(T602Parser):

    def __init__(self):
        T602Parser.__init__(self)
        self.output = array('u')
    
    def handle_data(self, data):
        self.output.fromunicode(unicode(data))

    def handle_soft_eol(self):
        self.handle_whitespace()

    def handle_hard_eol(self):
        self.handle_data(u'\n')

    def handle_soft_spaces(self, number):
        self.handle_whitespace()

    def handle_hard_space(self):
        self.handle_data(u'\u00a0') # U+00A0 NO-BREAK SPACE

    def handle_newpage(self):
        pass

    def handle_whitespace(self):
        self.handle_data(u' ')

    def handle_eof(self):
        pass

    def handle_font_change(self, font):
        pass

    def handle_sup_on(self):
        self.handle_data(SUP_ON_TAG)

    def handle_sup_off(self):
        self.handle_data(SUP_OFF_TAG)

    def handle_sub_on(self):
        self.handle_data(SUB_ON_TAG)

    def handle_sub_off(self):
        self.handle_data(SUB_OFF_TAG)

    def handle_bold_on(self):
        self.handle_data(BOLD_ON_TAG)

    def handle_bold_off(self):
        self.handle_data(BOLD_OFF_TAG)

    def handle_italics_on(self):
        self.handle_data(ITALICS_ON_TAG)

    def handle_italics_off(self):
        self.handle_data(ITALICS_OFF_TAG)

    def handle_wide_on(self):
        self.handle_data(WIDE_ON_TAG)

    def handle_wide_off(self):
        self.handle_data(WIDE_OFF_TAG)

    def handle_tall_on(self):
        self.handle_data(TALL_ON_TAG)

    def handle_tall_off(self):
        self.handle_data(TALL_OFF_TAG)
 
    def handle_big_on(self):
        self.handle_data(BIG_ON_TAG)

    def handle_big_off(self):
        self.handle_data(BIG_OFF_TAG)

    def handle_underline_on(self):
        self.handle_data(UNDERLINE_ON_TAG)

    def handle_underline_off(self):
        self.handle_data(UNDERLINE_OFF_TAG)


    # Overridable -- handle invalid control character
    def handle_invalid_cc(self, c):
        self.error("Invalid control character 0x%02x" % ord(c))
        


p = My602Parser()
f = open(args[0])
for i in f.readlines():
    p.feed(i)
p.close()

sys.stdout.write(p.output.tounicode().encode('utf-8'))
