#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
# Setup script for the elementtree library
# $Id: setup.py 2193 2004-12-05 18:03:00Z fredrik $
#
# Usage: python setup.py install
#

from distutils.core import setup

try:
    # add download_url syntax to distutils
    from distutils.dist import DistributionMetadata
    DistributionMetadata.classifiers = None
    DistributionMetadata.download_url = None
except:
    pass

DESCRIPTION="T602Parser - a 602 word processor parser for Python."

LONG_DESCRIPTION="""\
Text602 was a very popular word processor for IBM PC MS DOS
compatibles, used in Czechoslovakia. T602Parser provides
a simple class modelled after HTMLParser that can be 
used to parse Text602 documents (MS DOS version, not Win602)
and to extract/convert data contained in them.
"""

setup(
    name="t602parser",
    version="0.1",
    author="Radovan Garabík",
    author_email="garabik-602@[147.213.138.8]",
    url="http://kassiopeia.juls.savba.sk/~garabik/software/602/",
    description=DESCRIPTION,
    long_description=LONG_DESCRIPTION,
    download_url="http://kassiop[eia.juls.savba.sk/~garabik/software/602/",
    license="GNU General Public License",
    py_modules=["T602Parser"],
    platforms="Python 2.0 and later.",
    classifiers=[
        "Development Status :: 4 - Beta",
        "Operating System :: OS Independent",
        "Topic :: Text Processing :: Markup",
        "Topic :: Text Editors :: Text Processing",
        "Intended Audience :: Developers",
        "Intended Audience :: Information Technology"
        ]
    )
